'SnapFrameToBottomMargin.csc
'Copyright 2004 by Abe Hendin <ventura@yourspeed.com>. Public domain.
'Version 1.00
'March 4, 2004
'
'Snaps the bottom of the current frame to the bottom margin of the page.
'
'VERSION HISTORY:
'3/4/2004: Initial release.

#ADDFOL "C:\Program Files\Corel\Ventura 10\Ventura\Scripts"
#INCLUDE "VpConst.csi"
#ADDFOL "C:\Program Files\Corel\Ventura 10\Scripts"
#INCLUDE "scpconst.csi"

#DEFINE APP_NAME			"Snap Frame to Bottom Margin"
#DEFINE VERSION_STRING		" -- v1.00"
#DEFINE PAGE_LEFT			1
#DEFINE PAGE_RIGHT			2

WITHOBJECT "CorelVentura.Automation.10"
	DIM lSelectionType AS LONG, iret AS INTEGER
	DIM lFrameIndex AS LONG
	DIM lFrameHeight AS LONG, lFrameTopYPos AS LONG
	DIM lCurrPN AS LONG, bLeftPage AS BOOLEAN
	DIM lPageType AS LONG
	DIM lPageHeight AS LONG, lPageMarginBottom AS LONG
	DIM lFrameYPosCorrected AS LONG
	
	lSelectionType = .GetSelectionType()
	IF lSelectionType <> SELECT_FRAME THEN
		iret = MESSAGEBOX("Please select a drawn frame.", APP_NAME + VERSION_STRING, \\
			MB_STOP_ICON + MB_OK_ONLY)
		STOP
	ELSE
		lFrameIndex = .CurrentFrameIndex() 'get ref to current frame
		IF lFrameIndex < 1 THEN 'invalid frame selection
			iret = MESSAGEBOX("Please select a drawn frame.", APP_NAME + VERSION_STRING, \\
				MB_STOP_ICON + MB_OK_ONLY)
			STOP
		ENDIF
	ENDIF
	
	'collect current info
	.FormatFrameGeneralGet , lFrameTopYPos, , lFrameHeight
	.FrameFirst TRUE 'select base page
	lCurrPN = .CurrentPageNumber(bLeftPage,2) 'get page side for accurate margin retrieval
	IF bLeftPage THEN
		lPageType = PAGE_LEFT
	ELSE
		lPageType = PAGE_RIGHT
	ENDIF
	.FormatFrameGeneralGet , , , lPageHeight
	.FormatFrameMarginsInsideGet lPageType, , , , lPageMarginBottom
	
	'calculate new position and apply
	lFrameYPosCorrected = lPageHeight - lPageMarginBottom - lFrameHeight
	.FrameFirst FALSE, lFrameIndex 'reselect frame
	.FormatFrameGeneral , lFrameYPosCorrected
END WITHOBJECT
